#include <stdio.h> 
#include <stdlib.h> 
#include "redlib.h"
#include "redlib.e" 

char	*s[9][9]; 
int	c[9][9]; 

int	count_print = 0; 

redgram	slot_constraint(d, i, j) 
  redgram	d; 
  int		i, j; 
{ 
  int		value, h, k, nc, ac, gs; 
  redgram	conj; 
  
  /* To enumerate the value of s[i][j]. */ 
  for(value =1; value <= 9; value++) {
/*  	
    if (c[i][j] && value != c[i][j]) 
    // If s[i][j] is given from input, then we can rid of 8 values. 
      continue; 
*/ 
    for (h = 0; h < 9; h++){
      if (h != i) {
      	// regulation for s[i][j] != s[h][j] in the same column.
      	conj = red_diagram("!(%s==%d && %s==%d)", 
            s[i][j], value, s[h][j], value 
        ); 
        if ((++count_print) < 100 && (gs = red_diagram_size(d, &nc, &ac)) < 30) { 
          fprintf(RED_OUT, "\nMutual exclusion to value:%1d at %s and %s:\nconstraint:\n", 
            value, s[i][j], s[h][j]
          ); 
          red_print_line(conj); 
          fprintf(RED_OUT, "\n"); 
          red_print_diagram(conj); 
          fprintf(RED_OUT, "input diagram:\n"); 
          red_print_line(d); 
          fprintf(RED_OUT, "\n"); 
          red_print_diagram(d); 
        }
        d = red_and(d, conj); 
        if (count_print < 100 && gs < 30) {
          fprintf(RED_OUT, "result diagram:\n"); 
          red_print_line(d); 
          fprintf(RED_OUT, "\n"); 
          red_print_diagram(d); 	
        } 
/*
        fprintf(RED_OUT, "%s && %s, after one conjunction.\n", s[i][j], s[h][j]); 
        red_print_graph(d); 
        fprintf(RED_OUT, "\n"); 
        fflush(RED_OUT); 
*/        
        // regulation for s[h][k] != s[i][j] in the same 3x3. 
        if ((h/3) == (i/3)) { 
          for (k = 0; k < 9; k++) {
            if ((k/3)==(j/3) && (k!=j)) {
              d = red_and(d, 
                red_diagram("!(%s==%d && %s==%d)", 
                  s[i][j], value, 
                  s[h][k], value
              ) );
/*
              fprintf(RED_OUT, "%s && %s, after one conjunction.\n", s[i][j], s[h][k]); 
              red_print_graph(d); 
              fprintf(RED_OUT, "\n"); 
              fflush(RED_OUT); 
*/
            } 
          } 
        }
      }
      if (h != j) {
      	// regulatin for s[i][j]!=s[i][h] in the same row.
        d = red_and(d, 
          red_diagram("!(%s==%d && %s==%d)",  
            s[i][j], value, 
            s[i][h], value
        ) );
/*
        fprintf(RED_OUT, "%s && %s, after one conjunction.\n", s[i][j], s[i][h]); 
        red_print_graph(d); 
        fprintf(RED_OUT, "\n"); 
        fflush(RED_OUT); 
*/
      }
    }
  } 
   
  h = red_push(d); 
  red_garbage_collect(RED_GARBAGE_SILENT);                                                                                                                                                                                                                                                         
  red_pop(h); 
  
  return(d); 
} 
  /* slot_constraint() */ 

  


#define	FLAG_MULTIPLE	1
#define	FLAG_SINGLE	0

main(argc, argv) 
  int	argc; 
  char	**argv; 
{ 
  char 		a, *start, *condition, *p;
  redgram	sol, cube; 
  int		i, j, k, u, v, h, m, lb[9][9], ub[9][9], flag;
  char 		stop[30]; 
  FILE 		*datafile;
 
  if (argc < 2)  {
    printf("Input file for sudoko not specified!\n"); 
    exit(0);    
  }
  datafile = fopen(argv[1], "r");
  if (datafile == NULL) {
    printf("Can't open the data file of sudoko!! \n");
    exit(0);
  }
 
  //RED_input_file("sample.d");  
  red_begin_session(RED_SYSTEM_UNTIMED, "sudoku", 2); 
  red_begin_declaration(); /* each process for a row on the board. */ 
  
  for (i = 0; i < 9; i++) {
    for (j = 0; j < 9; j++) { 
      s[i][j] = malloc(4); 
      sprintf(s[i][j], "d%1d%1d", i, j); 
      red_declare_variable(RED_TYPE_DISCRETE, 1, 9, "%s", s[i][j]);
    } 
  } 
  
  red_end_declaration(RED_NO_REFINED_GLOBAL_INVARIANCE);
    
  /* How to access a variable ? */ 
  
  //RED_print_variables();
  //RED_print_xtions();
  //RED_verify();
  
  /* Declaration of the 81 slot variable indices as a 9X9 arrays.  
   * Note this is not for the array of slot variable values.  
   * This is only for the slot variable indices.  
   */
  do {
    /* After the completion of the loop, sol should be the MBDD+CRD 
     * that records the solutions to your input board specification. 
     * Initially, we set sol to TRUE.
     */ 
    sol = red_true(); 
    /* Please fill in the code here to calculate the solution for 
     * the given sudoko puzzle. 
     * The details of the main processing body, that you should fill in, 
       include: 
        1. Read in the values of those given slots on the board and 
           construct the logic formula with the REDLIB procedures.  
        2. Iteratively restrict the formula you got in step 1 with 
           all the sudoko rules. 
       Now start filling in the main processing body in the following.
       |||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||| 
       VVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVVV
     */
    for (i = 0; i < 9; i++){
       for (j = 0; j < 9; j++){
         a = getc(datafile);
         if (a == '\n')
           a = getc(datafile); 
         sprintf(stop, "%c\0", a); 
         c[i][j] = atoi(stop); 
         if (c[i][j] != 0) {
           sol = red_and(sol, red_diagram("%s==%d", s[i][j], c[i][j]));
           sol = slot_constraint(sol, i, j); 
         }
       }
    }
    
    for(i = 0; i < 9; i++) {
      for(j = 0; j < 9; j++) {
      	if (c[i][j] == 0) 
	  sol = slot_constraint(sol, i, j); 
      }
    }
    
    /* ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
       ||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||
       After the main processing body of the loop, 
     * we are now ready to print out the solution board specification. 
     * We do this in two ways. 
     * In the first way, we print the board as a 9X9 char array. 
     * We do this by first invoking the depth-first traversing procedure 
     * red_process_DFS() for MBDD+CRD.  
     * For each node in the MBDD+CRD,  red_process_DFS() process the 
     * node with procedure max_rec() and each arc of the node with 
     * procedure arc_noop().  
     *
     * In the second way, we print the MBDD+CRD of sol as a single-line 
     * Boolean formula.  
     */
    
/*
    red_print_diagram(sol); 
*/
    i = red_diagram_discrete_model_count(sol); 
    
    switch (i) { 
    case 0: 
      fprintf(RED_OUT, "\nNo solutions!\n"); 
      break; 
    case 1:  
      fprintf(RED_OUT, "\nOnly 1 solution\n"); 
      break; 
    default: 
      fprintf(RED_OUT, "\nTotal %1d solutions!\n", i); 
      break; 
    } 

    cube = red_first_cube(sol); 
    for (; cube != red_false(); cube = red_next_cube(sol)) { 
      fprintf(RED_OUT, "\n\nOne solution:\n"); 
      flag = FLAG_SINGLE; 
      for (i = 0; i < 9; i++) { 
        for (j = 0; j < 9; j++) { 
          red_get_cube_discrete_value(
            cube, s[i][j], &(lb[i][j]), &(ub[i][j])
          ); 
          if (lb[i][j] < ub[i][j]) 
            flag = FLAG_MULTIPLE; 
          fprintf(RED_OUT, "%1d", lb[i][j]); 
        } 
        fprintf(RED_OUT, "\n"); 
      }
      if (flag != FLAG_MULTIPLE) 
        continue; 
      fprintf(RED_OUT, "\n\nOne more solution:\n"); 
      for (i = 0; i < 9; i++) { 
        for (j = 0; j < 9; j++) { 
          fprintf(RED_OUT, "%1d", ub[i][j]); 
        } 
        fprintf(RED_OUT, "\n"); 
      }
      fprintf(RED_OUT, "\n"); 
    }
    fprintf(RED_OUT, "\n------------------------------------------------------------\n");
    red_print_line(sol);
    fprintf(RED_OUT, "\nsolution diagram:\n"); 
    red_print_diagram(sol); 
    
    break;        
  } 
  while(   strcmp(fgets(stop, 30, datafile), "end") != 0 
        && strcmp(fgets(stop, 30, datafile), "END") != 0
        );
  red_end_session();                     
  fclose(datafile);
}
  /* main() */ 
